this.name					= "april_worldScript.js";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Script for APRIL reloader";
this.version				= "1.03";

this.startUp = function()
	{
	if(player.ship.equipmentStatus("EQ_APRIL") === "EQUIPMENT_UNAVAILABLE") { return; }

	if(!missionVariables.aprilExpanded)	{ missionVariables.aprilExpanded = "FALSE"; }
	this.storeSpace = player.ship.missileCapacity;
	if(missionVariables.aprilExpanded === "TRUE") { this.storeSpace *= 2; }
	if(missionVariables.aprilMemory)
		{ 
		this.storeArray = missionVariables.aprilMemory.split(":");
		this.validateArray();
		}
	else
		{ this.storeArray = []; }
	this.missileArray = [];
	missionVariables.aprilLoad = this.storeArray.length;
	if(this.storeArray.length === this.storeSpace)
		{ missionVariables.aprilFull = "TRUE"; }
	else
		{ missionVariables.aprilFull = "FALSE"; }	
	}

this.validateArray = function()
	{
	if(this.storeArray.length === 0) { return; }
	var arrayCounter = this.storeArray.length - 1;
	for(arrayCounter = this.storeArray.length - 1;arrayCounter>=0;arrayCounter--)
		{
		if(EquipmentInfo.allEquipment.indexOf(EquipmentInfo.infoForKey(this.storeArray[arrayCounter])) === -1)
			{ this.storeArray.splice(arrayCounter,1); }
		}
	this.tidyArray();	
	}
	
this.playerWillSaveGame = function(type)
	{ 
	if(player.ship.equipmentStatus("EQ_APRIL") === "EQUIPMENT_UNAVAILABLE") { return; }

	this.storeMissileArray = "";
	var storeCounter = 0;
	for(storeCounter = 0;storeCounter<this.storeArray.length;storeCounter++)
		{ this.storeMissileArray = this.storeMissileArray + this.storeArray[storeCounter] + ":"; }
	this.storeMissileArray = this.storeMissileArray.slice(0,-1);	
	missionVariables.aprilMemory = this.storeMissileArray;
	}	

this.playerBoughtNewShip = function(ship)
	{
	if(player.ship.equipmentStatus("EQ_APRIL") === "EQUIPMENT_UNAVAILABLE") { return; }

	this.storeArray = [];
	this.missileArray = [];
	if(missionVariables.aprilMemory) { delete missionVariables.aprilMemory; }
	if(missionVariables.aprilFull) { delete missionVariables.aprilFull; }
	if(missionVariables.aprilLoad) { delete missionVariables.aprilLoad; }
	if(missionVariables.aprilExpanded) { delete missionVariables.aprilExpanded; }
	this.storeSpace = player.ship.missileCapacity;
	}
	
this.playerBoughtEquipment = function(equipment)
	{
	switch(equipment)
		{	
		case "EQ_APRIL":
			{
			missionVariables.aprilExpanded = "FALSE";
			missionVariables.aprilFull = "FALSE";
			this.missileArray = [];
			this.storeArray = [];
			missionVariables.aprilLoad = 0;
			this.storeSpace = player.ship.missileCapacity;
			break;
			}	
		case "EQ_APRIL_UNLOAD":
			{
			player.ship.removeEquipment("EQ_APRIL_UNLOAD");
			this.aprilTriggered();
			break;
			}
		case "EQ_APRIL_EXPANSION":
			{
			missionVariables.aprilExpanded = "TRUE";
			missionVariables.aprilFull = "FALSE";
			this.storeSpace = player.ship.missileCapacity * 2;
			break;
			}
		case "EQ_APRIL_INVENTORY":
			{
			player.ship.removeEquipment("EQ_APRIL_INVENTORY");
			this.displayInventory();
			break;
			}	
		case "EQ_APRIL_TRANSFER":
			{
			player.ship.removeEquipment("EQ_APRIL_TRANSFER");
			if(this.storeArray.length === this.storeSpace)
				{
				player.consoleMessage("APRIL capacity filled");
				missionVariables.aprilFull = "TRUE";
				}
			else
				{
				this.missileArray = [];
				this.mmLoaded = "no";
				var loopCounter = 0 ; // reset the counter
				for(loopCounter = 0;loopCounter < player.ship.missiles.length;loopCounter++)
					{
					if(player.ship.missiles[loopCounter].equipmentKey === "EQ_ARMOURY_MISSILEMACHINE_MINE")
						{ this.mmLoaded = "yes"; }
					else
						{ this.missileArray.push(player.ship.missiles[loopCounter].equipmentKey); }
					}				

				player.ship.awardEquipment("EQ_MISSILE_REMOVAL");
				if(this.mmLoaded === "yes") 
					{
					player.ship.awardEquipment("EQ_ARMOURY_MISSILEMACHINE_MINE"); 
					this.mmLoaded = "no";
					}
				
				this.availableSpace = this.storeSpace - this.storeArray.length;
				
				var listCounter = 0 ; // reset the counter
				for(listCounter = 0;listCounter<this.availableSpace;listCounter++)
					{ this.storeArray.push(this.missileArray.pop()); }
				
				this.tidyArray();
				
				if(this.storeArray.length === this.storeSpace)
					{
					player.consoleMessage("APRIL capacity filled");
					missionVariables.aprilFull = "TRUE";
					}
					
				if(this.missileArray.length > 0)	
					{
					var listCounter = 0 ; // reset the counter
					for(listCounter = 0;listCounter<this.missileArray.length;listCounter++)
						{ player.ship.awardEquipment(this.missileArray[listCounter]); }
					}
				}	
			missionVariables.aprilLoad = this.storeArray.length;
			break;
			}
		}	
	}
	
this.tidyArray = function()
	{
	var loopCounter = this.storeArray.length - 1 ; // reset the counter
	for(loopCounter = this.storeArray.length - 1;loopCounter >= 0;loopCounter--)
		{ if(this.storeArray[loopCounter] === undefined) { this.storeArray.pop(); } }				
	}

this.shipReleasedEquipment = this.shipFiredMissile = function()
	{
	if(player.ship.equipmentStatus("EQ_APRIL") === "EQUIPMENT_UNAVAILABLE") { return; }
	this.missileCheckTimer = new Timer(this, this.checkMissiles, 0.25); 
	}
	
this.checkMissiles = function()
	{
	if(player.ship.equipmentStatus("EQ_APRIL") !== "EQUIPMENT_OK" || player.ship.missiles.length > 0)
		{ return; }
	this.aprilTriggered();
	}	
	
this.aprilTriggered = function()
	{
	if(this.storeArray.length === 0)
		{
		player.consoleMessage("APRIL store empty");
		missionVariables.aprilLoad = this.storeArray.length;
		return;
		}
		
	this.freePylons = player.ship.missileCapacity - player.ship.missiles.length;
	if(this.freePylons === 0)
		{
		player.consoleMessage("All pylons are full");
		missionVariables.aprilLoad = this.storeArray.length;
		return;
		}
		
	var listCounter = 0 ; // reset the counter
	for(listCounter = 0;listCounter<this.freePylons;listCounter++)
		{
		this.transfer = this.storeArray.pop();
		if(this.transfer !== undefined) { player.ship.awardEquipment(this.transfer); }
		}
		
	this.tidyArray();	
	missionVariables.aprilFull = "FALSE";
	missionVariables.aprilLoad = this.storeArray.length;
	}
	
this.guiScreenChanged = function(to, from)
	{
	if(player.ship.docked || player.ship.equipmentStatus("EQ_APRIL") !== "EQUIPMENT_OK" || player.ship.equipmentStatus("EQ_MULTIBAY") === "EQUIPMENT_OK") { return; }
		
	if(to && from && to == "GUI_SCREEN_MARKET" && from == "GUI_SCREEN_STATUS")
			{ this.displayInventory(); }	
	}		

this.displayInventory = function()
	{
	mission.runScreen({title:"APRIL Content"});
	if(this.storeArray.length === 0)
		{
		mission.addMessageText("\n\n\nThe APRIL system is currently empty.\n\nWeaponry can be stored via the equipment screen when docked.");
		return;
		}
	else
		{
		var minShow = 0;
		if(this.storeArray.length > 20) { minShow = this.storeArray.length - 20; }
		var pylonCounter = this.storeArray.length -1; // reset the counter
		var displayCounter = 1;
		for(pylonCounter = this.storeArray.length - 1; pylonCounter >= minShow; pylonCounter--)
			{ 
			mission.addMessageText(displayCounter + " - " + EquipmentInfo.infoForKey(this.storeArray[pylonCounter]).name); 
			displayCounter++;
			}
		if(this.storeArray.length < 18) { mission.addMessageText("\nCapacity used: " + this.storeArray.length + " of " + this.storeSpace); }
		if(this.storeArray.length > 20) { mission.addMessageText("...                                                 Press Space Commander"); }
		}
	}